function portalservice_OnLoad()

if EPAConfig == nil then
	EPAConfig = {
		["PortalPrice"] = 'Free',
		["TradeChannel"] = '2',
		["ReadySound"] = 'true',
		["SoundID"] = '1',
		["Keyword"] = '!portal',
		["Advert"] = ''
	}
end

if EPAConfig.PortalPrice == nil then
	EPAConfig.PortalPrice = "Free"
end

if EPAConfig.Advert == nil or EPAConfig.Advert == "" then
	createadvert()
end

local varload = CreateFrame("Frame")
varload:RegisterEvent("ADDON_LOADED")
varload:RegisterEvent("PLAYER_LEVEL_UP")
varload:SetScript("OnEvent", function(self, event, arg1)
	
	if event == "ADDON_LOADED" and arg1 == "EasyPortalAdvert" then

		if OtherPlaceName == nil or AshranPlace == nil then
			local englishFaction, localizedFaction = UnitFactionGroup("player")

			if englishFaction == "Alliance" then
				OtherPlaceName = "Theramore"
				AshranPlace = "Stormshield"
			elseif englishFaction == "Horde" then
				OtherPlaceName = "Stonard"
				AshranPlace = "Warspear"
			end	
		end
		
		local localizedClass, englishClass = UnitClass("player")
		local char = UnitName("player")
		local level = UnitLevel("player")
		local englishFaction, localizedFaction = UnitFactionGroup("player")

		if englishClass ~= "MAGE" then
			message("|cFFFFFF00Easy Portal Advert|r\n|cFFFFFFFFThe character you are currently playing on is not a Mage. Please disable Easy Portal Advert on this character.")
		else

		if level < 42 and englishClass == "MAGE" then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Welcome to EPA v" .. GetAddOnMetadata("EasyPortalAdvert", "Version") .. ". Because you are not yet Level 42, all you can do is set your prices.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r v" .. GetAddOnMetadata("EasyPortalAdvert", "Version") .. " loaded. Use /epa help for a list of commands.")
			end
		end

		plugincheck()

		if englishFaction == "Alliance" and OtherPlaceName == "Stonard" and AshranPlace == "Warspear" then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r This character appears to have been faction changed from Horde. Ads will now say Theramore/Stormshield instead of Stonard/Warspear.")
			OtherPlaceName = "Theramore"
			AshranPlace = "Stormshield"
		end

		if englishFaction == "Horde" and OtherPlaceName == "Theramore" and AshranPlace == "Stormshield" then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r This character appears to have been faction changed from Alliance. Ads will now say Stonard/Warspear instead of Theramore/Stormshield.")
			OtherPlaceName = "Stonard"
			AshranPlace = "Warspear"
		end			
	end

	if event == "PLAYER_LEVEL_UP" and arg1 == 42 then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r You may now use all of EPA's features.")
		createadvert()
	end
	
	if event == "PLAYER_LEVEL_UP" and arg1 == 74 then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r You may now use the Whispers plugin.")
		createadvert()
	end
	
	if event == "PLAYER_LEVEL_UP" and arg1 == 85 or arg1 == 90 or arg1 == 100 then
		createadvert()
	end

end)

SlashCmdList["ALLPORTS"] = allports
	SLASH_ALLPORTS1 = "/all" -- Changes the price of all portals to the amount specified.

SlashCmdList["KEYWORD"] = keywordset
	SLASH_KEYWORD1 = "/key" -- Set the keyword people need to whisper for prices.

SlashCmdList["LEAVEPARTY"] = leaveparty_command
	SLASH_LEAVEPARTY1 = "/lp" -- Quickly leave a party.

SlashCmdList["SETCDSOUND"] = setcdsound
	SLASH_SETCDSOUND1 = "/cda" -- Set the sound played when a portal ends its cooldown.

SlashCmdList["PREVIEWSOUND"] = previewsound
	SLASH_PREVIEWSOUND1 = "/cdp" -- Preview the sound played when a portal ends its cooldown.

SlashCmdList["PORTALADVERT"] = portaladvert_command
	SLASH_PORTALADVERT1 = "/ad" -- Display the advert

SlashCmdList["TCHAN"] = tradehandler
	SLASH_TCHAN1 = "/tc" -- Set the Trade Channel number.

SlashCmdList["EPAHANDLER"] = epahandler
	SLASH_EPAHANDLER1 = "/epa" -- Handles other EPA related commands.

end

function keywordset(msg, editbox)

if msg == "" or msg == nil then
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r |cFFFF0000[Error]|r Please enter a value.")
else
	EPAConfig.Keyword = msg
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Your whisper keyword has been changed to |cFF00FFFF" .. msg .. "|r.")
end

end

function leaveparty_command()
	LeaveParty()
end

function setcdsound(msg, editbox)

local id = tonumber(msg)

if id < 1 or id > 3 then
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r |cFFFF0000[Error]|r Please enter a value between 1 and 3.")
else
	EPAConfig.SoundID = id
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Alert sound changed to |cFF00FFFFportalready0"..id..".mp3|r.")
end

end

function previewsound(msg, editbox)

local id = tonumber(msg)

if id < 1 or id > 3 then
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r |cFFFF0000[Error]|r Please enter a value between 1 and 3.")
else
	PlaySoundFile("Interface\\AddOns\\EasyPortalAdvert\\sound\\portalready0"..id..".mp3")
end

end

function portaladvert_command()

-- This section is the actual advert itself.

local lang = GetDefaultLanguage("player")

SendChatMessage(tostring(EPAConfig.Advert),"CHANNEL",lang,EPAConfig.TradeChannel)

end

function tradehandler(msg, editbox)

if msg == nil or msg == "" then
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r |cFFFF0000[Error]|r Please enter a number.")
else
	local tradechannel = tonumber(msg)
	EPAConfig.TradeChannel = tradechannel
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Trade Channel number changed to |cFF00FFFF" .. msg .. "|r.")
end

end

function epahandler(msg)

local localizedClass, englishClass = UnitClass("player")
local englishFaction, localizedFaction = UnitFactionGroup("player")
local level = UnitLevel("player")

if msg == nil or msg == "" then
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Please use one of the following arguments:")
	DEFAULT_CHAT_FRAME:AddMessage("cost/info, help, sound, create")
elseif msg == "sound" then
	if EPAConfig.ReadySound == "true" then
		EPAConfig.ReadySound = 'false'
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r The cooldown alert sound has been |cFFFF0000disabled|r.")
	elseif EPAConfig.ReadySound == "false" then
		EPAConfig.ReadySound = 'true'
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r The cooldown alert sound has been |cFF00FF00enabled|r.")
	end
elseif msg == "cost" or msg == "info" then

local GUI = LibStub("AceGUI-3.0") 
local frame = GUI:Create("Frame") 

frame:SetTitle("Settings") 
frame:SetStatusText("Version " ..GetAddOnMetadata("EasyPortalAdvert", "Version")) 
local txt,sf 
local example_txt = ("EPA is currently using the following settings:\n\n|cFF00FF00Cost of all portals:|r " .. EPAConfig.PortalPrice .. ".\n\n|cFF00FF00Trade Channel:|r " .. EPAConfig.TradeChannel .. "\n\nYour Whisper keyword is: |cFF00FFFF" .. EPAConfig.Keyword .. "|r\n\nYour alert sound is: |cFF00FFFFInterface\47AddOns\47EasyPortalAdvert\47sound\47portalready0" .. EPAConfig.SoundID .. ".mp3|r.\n\nYour advert is: |cFF00FFFF" .. tostring(EPAConfig.Advert) .. "|r\n\n"):rep(1) 
	 
frame:SetLayout("Fill") 
	 
txt = GUI:Create("Label") 
txt:SetFullWidth(true) 
txt:SetText(example_txt) 

sf = GUI:Create("ScrollFrame") 
sf:SetLayout("Flow") 
sf:AddChild(txt) 

frame:AddChild(sf)

elseif msg == "help" then

local GUI = LibStub("AceGUI-3.0") 
local frame = GUI:Create("Frame") 

frame:SetTitle("EPA Help") 
frame:SetStatusText("Version " ..GetAddOnMetadata("EasyPortalAdvert", "Version")) 
local txt,sf 
local example_txt = ("|cFFFFFF00EPA COMMANDS|r\n\n|cFF00FF00/epa info|r - Display the current settings being used by EPA.\n|cFF00FF00/epa sound|r - Toggle the cooldown alert sound on or off.\n|cFF00FF00/epa create|r - Force EPA to recreate your advert.\n\n|cFFFFFF00PRICE SETTINGS|r\n\n|cFF00FF00/all <number>|r - Set the price for all of your portals.\n\n|cFFFFFF00CHANNEL SETTINGS|r\n\n|cFF00FF00/tc <number>|r - Tells EPA what number to use for Trade chat (usually 2).\n\n|cFFFFFF00DISPLAYING ADVERTS|r\n\n|cFF00FF00/ad|r - Displays your advert in the Trade channel.\n\n|cFFFFFF00MESSAGE SETTINGS|r\n\n|cFF00FF00/key <message>|r - Set the keyword used by the Whispers plugin.\n\n|cFFFFFF00ALERT SOUND SETTINGS|r\n\n|cFF00FF00/cda <number>|r - Tells EPA which sound to play when a portal finishes its cooldown (unless this feature is turned off).\n|cFF00FF00/cdp <number>|r - Preview one of the |cFF00FFFFthree|r alert sounds.\n\n|cFFFFFF00OTHER COMMANDS|r\n\n|cFF00FF00/lp|r - Quickly leave your current party."):rep(1) 	 
frame:SetLayout("Fill") 
	 
txt = GUI:Create("Label") 
txt:SetFullWidth(true) 
txt:SetText(example_txt) 

sf = GUI:Create("ScrollFrame") 
sf:SetLayout("Flow") 
sf:AddChild(txt) 

frame:AddChild(sf)

elseif msg == "create" then
	createadvert()
end
end

function plugincheck()

	cdcloaded = IsAddOnLoaded("EPA-CooldownMonitor")
	food = IsAddOnLoaded("EPA-Refreshments")
	wmsg = IsAddOnLoaded("EPA-Whispers")

		if cdcloaded == true then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Cooldown Monitor is |cFF00FF00enabled|r.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Cooldown Monitor is |cFFFF0000disabled|r.")
		end

		if food == true then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Refreshments plugin is |cFF00FF00enabled|r.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Refreshments plugin is |cFFFF0000disabled|r.")
		end

		if wmsg == true then
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Whispers plugin is |cFF00FF00enabled|r.")
		else
			DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Whispers plugin is |cFFFF0000disabled|r.")
		end

end

function allports(msg, editbox)

if msg == nil or msg == "" then
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r |cFFFF0000[Error]|r Please enter a price.")
elseif msg == "free" or msg == "Free" or msg == "0" then
	EPAConfig.PortalPrice = 'Free'
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r All your portals are now free.")
	createadvert()
else
	local priceall = msg
	EPAConfig.PortalPrice = priceall
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r All your portals are now " .. priceall .. " each.")
	createadvert()
end

end

function createadvert()

local level = UnitLevel("player")
local englishFaction, localizedFaction = UnitFactionGroup("player")
local lang = GetDefaultLanguage("player")

if level >= 42 and EPAConfig.PortalPrice == "Free" then
	EPAConfig.Advert = "Free portals!"
elseif EPAConfig.PortalPrice ~= "Free" then
	EPAConfig.Advert = "Portals available for " .. EPAConfig.PortalPrice .. " each."
end

DEFAULT_CHAT_FRAME:AddMessage("|cFFFFFF00[Easy Portal Advert]|r Your advert has been recreated.")

end